# TP 15 : Matrices
# BCPST1B 2023-2024
# Lycée Hoche, Versailles
# L.-C. LEFÈVRE

#%% fonctions données
# exécuter une fois pour toute la cellule

from random import randint
import numpy as np # pour tricher

# matrice nulle de taille (n, p)
def matrice_nulle(n, p):
    return [[0 for _ in range(p)] for _ in range(n)]

# matrice de coefficients au hasard entre -9 et 9, de taille (n, p)
def matrice_hasard(n, p):
    return [[randint(-9, 9) for _ in range(p)] for _ in range(n)]

# affiche la matrice, bien mise en forme, en trichant
def matrice_print(A):
    print(np.array(A))

#%% exercice 1

def taille(A):
    n = ...
    p = ...
    return (n, p)

#%% exercice 2

def identité(n):
    A = matrice_nulle(n, n)
    for ... :
        A[...][...] = ...
    return A

# test
A = identité(5)
matrice_print(A)

#%% exercice 3

def diagonale(L):
    n = ...
    A = ...
    for ... :
       ...
    return A

# test
L = [1, 3, 5, 7]
A = diagonale(L)
matrice_print(A)

#%% exercice 4

def somme(A, B):
    (n, p) = taille(A)
    (n2, p2) = taille(B)
    assert n == n2 and p == p2, "ça ne marche pas, revois ton cours"
    S = ...
    for ... :
        ...
    return S

# test
A = matrice_hasard(4, 5)
B = matrice_hasard(4, 5)
matrice_print(A)
matrice_print(B)
S = somme(A, B)
matrice_print(S)

#%% exercice 5

def produit_constante(A, a):
    (n, p) = taille(A)
    B = ...
    for ... :
        ...
    return B

# test
A = matrice_hasard(4, 5)
a = randint(-9, 9)
matrice_print(A)
print(a)
B = produit_constante(A, a)
matrice_print(B)

#%% exercice 6

def coeff_produit(A, B, i, j):
    (n, q) = taille(A)
    (q2, p) = taille(B)
    assert q == q2, "aïe, tu devrais revoir ton cours"
    ...

def produit(A, B):
    (n, q) = taille(A)
    (q2, p) = taille(B)
    assert q == q2, "il faut VRAIMENT que tu revoies ton cours"
    P = matrice_nulle(...)
    for ... :
        ...
    return P

# test
A = matrice_hasard(...)
B = matrice_hasard(...)
matrice_print(A)
matrice_print(B)
P = produit(A, B)
matrice_print(P)

#%% exercice 8

def puissance(A, N):
    (n, p) = taille(A)
    assert n == p, "non mais sérieusement, encore ???"
    ...

# test, voir cours et programme de colle
A = [[2, 1, 0], [0, 2, 1], [0, 0, 2]]
matrice_print(A)
for N in range(5):
    print(N)
    P = puissance(A, N)
    matrice_print(P)

#%% exercice 9

def est_diagonale(A):
    """ renvoie True si la matrice A est diagonale, False sinon """
    ...

# test
A = [[1, 0, 0], [0, 3, 0], [0, 0, 5]]
matrice_print(A)
print(est_diagonale(A))
B = [[1, 2, 0], [0, 3, 0], [0, 0, 5]]
matrice_print(B)
print(est_diagonale(B))
C = [[0, 0, 0], [0, 3, 0], [0, 0, 5]]
matrice_print(C)
print(est_diagonale(C))
D = [[0, 0, 0], [-1, 3, 0], [0, 0, 5]]
matrice_print(D)
print(est_diagonale(D))
E = [[1, 0, 0], [0, 3, 0], [0, 1, 5]]
matrice_print(E)
print(est_diagonale(E))
      
#%% exercice 10

def est_triangulaire_supérieure(A):
    """ renvoie True si la matrice A est triangulaire supérieure, False sinon """
    ...

A = [[1, 2, 3], [0, 3, -2], [0, 0, 5]]
matrice_print(A)
print(est_triangulaire_supérieure(A))
B = [[0, 2, 1], [0, 3, -2], [0, 0, 5]]
matrice_print(B)
print(est_triangulaire_supérieure(B))
C = [[1, 2, 3], [-7, 3, 0], [0, 0, 5]]
matrice_print(C)
print(est_triangulaire_supérieure(C))
D = [[1, 0, 0], [0, 3, 4], [0, 2, 5]]
matrice_print(D)
print(est_triangulaire_supérieure(D))

#%% à vous !

# on pourra échelonner les matrices suivantes
A1 = [[1, 0, -1], [-2, -1, 4], [0, 1, -3]]
A2 = [[-1, 3, -1], [0, -2, 0], [2, -6, 2], [1, -4, 1]]

